/*
 * Range
 *
 *
 * Index
 * - Input
 * - Value
 * - Slider
 * - Progress
 * - Cursor
 */

:host {
  display: block;
}

.form-group{
  width: 100%;
}

.form-range {
  position: relative;
  display: flex;
  flex-direction: column;
  width: 100%;
  margin-bottom: 6px;
}

/* INPUT
 -------------------- */

.form-range-input {
  position: relative;
  z-index: 1;
  width: 100%;
  background: transparent;
  outline: 0;
  appearance: none;
}

/* VALUE
 -------------------- */

.form-range > output::after {
  display: block;
  font-size: var(--road-label-medium);
  text-align: right;
  content: counter(variable);
  counter-reset: variable var(--value);
}

/* SLIDER
 -------------------- */

.form-range-label {
  position: absolute;
  top: 0;
  left: 0;
  width: 1px;
  height: 1px;
  padding: 0;
  margin: -1px;
  overflow: hidden;
  clip: rect(0 0 0 0);
  border: 0;
}

.form-range-progress {
  position: relative;
  z-index: 0;
  display: block;
  width: 100%;
  margin-top: -1rem;
}

.form-range-input::-webkit-slider-runnable-track {
  border: 0;
  appearance: none;
}

.form-range-input::-moz-range-track {
  height: 0.5rem;
  border: 0;
  appearance: none;
}

.form-range-progress::before {
  display: block;
  height: 0.5rem;
  content: "";
  background-color: var(--road-on-surface-disabled);
  border: 0;
  border-radius: 1.125rem;
}

/* PROGRESS
 -------------------- */

.form-range-progress.sc-road-range::after {
  position: absolute;
  top: 0;
  right: 0;
  left: 0;
  display: block;
  width: calc(((var(--value) - var(--min)) * 100%) / (var(--max) - var(--min)));
  height: 0.5rem;
  content: "";
  background: var(--road-primary);
  border-radius: 1.125rem;
}

:host(.disabled) .form-range-progress.sc-road-range::after {
  background: var(--road-surface-disabled);
}

/* CURSOR
-------------------- */

.form-range-input::-webkit-slider-thumb {
  position: relative;
  z-index: 1;
  width: 1.625rem;
  height: 1.625rem;
  cursor: grab;
  background: var(--road-surface);
  border: none;
  border-radius: 1.625rem;
  box-shadow: 0 0.1875rem 0.375rem rgba(0, 0, 0, 0.24);
  appearance: none;
}

.form-range-input::-moz-range-thumb {
  position: relative;
  z-index: 1;
  box-sizing: border-box;
  width: 1.625rem;
  height: 1.625rem;
  margin-top: -0.625rem;
  cursor: grab;
  background: var(--road-surface);
  border: none;
  border-radius: 1.625rem;
  box-shadow: 0 0.1875rem 0.375rem rgba(0, 0, 0, 0.24);
  appearance: none;
}

/* Styles for disabled state */
:host(.disabled) .form-range-input::-webkit-slider-thumb,
:host(.disabled) .form-range-input::-moz-range-thumb {
  cursor: not-allowed;
  background: var(--road-on-surface-disabled);
  box-shadow: none;
}

:host(.disabled) .form-range-input {
  pointer-events: none;
}

:host(.disabled) {
  cursor: not-allowed;
}

/**
 *  Focus state
 */

:host(:not(.disabled).focus-visible) .form-range-input::-webkit-slider-thumb,
:host(:not(.disabled):active) .form-range-input::-webkit-slider-thumb,
:host(:not(.disabled):focus) .form-range-input::-webkit-slider-thumb {
  background: var(--road-input-surface-variant);
  border: 0.5rem solid var(--road-grey-100-new);
}

:host(:not(.disabled).focus-visible) .form-range-input::-moz-range-thumb,
:host(:not(.disabled):active) .form-range-input::-moz-range-thumb,
:host(:not(.disabled):focus) .form-range-input::-moz-range-thumb {
  background: var(--road-input-surface-variant);
  border: 0.5rem solid var(--road-grey-100-new);
}

/* DATALIST
 -------------------- */

::slotted(datalist) {
  display: flex;
  justify-content: space-between;
}

::slotted(datalist) option {
  width: 32px;
  margin: 0;
  font-size: var(--road-label-medium);
  text-align: center;
}

